#include "config.h"
#include <iostream>

#define VNAME(value) (#value)

namespace graft_cv{
	CGCvConfig::CGCvConfig()	
		:m_cparam(0)
	{		
	};
	CGCvConfig::~CGCvConfig()
	{
	};

	void CGCvConfig::setConfParam(ConfigParam*cp)
	{
		m_cparam = cp;
	}
	void CGCvConfig::write(cv::FileStorage &fs)const{
		assert(m_cparam!=0);
		fs << "{" 
			<< "image_show"<<  m_cparam->image_show
			<< "image_return"<<  m_cparam->image_return
			
			<<"image_save"<<m_cparam->image_save
			<<"image_depository"<<m_cparam->image_depository
			<<"image_backup_days"<<m_cparam->image_backup_days
			<<"model_path_grab"<<m_cparam->model_path_grab
			<<"object_threshold_grab"<<m_cparam->object_threshold_grab
			<<"nms_threshold_grab"<<m_cparam->nms_threshold_grab
			<< "grid_row_grab" << m_cparam->grid_row_grab
			<< "grid_col_grab" << m_cparam->grid_col_grab
			<< "grid_padding_grab" << m_cparam->grid_padding_grab
			<< "offset_grab" << m_cparam->offset_grab
			<< "min_distance_grab" << m_cparam->min_distance_grab
			<< "min_area_ratio_grab" << m_cparam->min_area_ratio_grab
			<< "max_area_ratio_grab" << m_cparam->max_area_ratio_grab
			<< "rot_degree_grab" << m_cparam->rot_degree_grab

			<< "model_path_cut" << m_cparam->model_path_cut
			<< "object_threshold_cut" << m_cparam->object_threshold_cut
			<< "nms_threshold_cut" << m_cparam->nms_threshold_cut
			<< "grid_row_cut" << m_cparam->grid_row_cut
			<< "grid_col_cut" << m_cparam->grid_col_cut
			<< "grid_padding_cut" << m_cparam->grid_padding_cut
			<< "min_area_ratio_cut" << m_cparam->min_area_ratio_cut
			<< "max_area_ratio_cut" << m_cparam->max_area_ratio_cut
			<< "kp3_weight_cut" << m_cparam->kp3_weight_cut

			
			<< "}"; 	
	};
	void CGCvConfig::read(const cv::FileNode& node){ //Read serialization for this class
		assert(m_cparam!=0);
		m_cparam->image_show = (bool)(int)node["image_show"];
		m_cparam->image_return = (bool)(int)node["image_return"];
		

		m_cparam->image_save = (bool)(int)node["image_save"];
		m_cparam->image_depository	=(string)node["image_depository"];
		m_cparam->image_backup_days = (int)node["image_backup_days"];
		m_cparam->model_path_grab =(string)node["model_path_grab"];
		m_cparam->object_threshold_grab = (float)node["object_threshold_grab"];
		m_cparam->nms_threshold_grab = (float)node["nms_threshold_grab"];
		m_cparam->grid_row_grab = (int)node["grid_row_grab"];
		m_cparam->grid_col_grab	= (int)node["grid_col_grab"];
		m_cparam->grid_padding_grab	= (int)node["grid_padding_grab"];
		m_cparam->offset_grab = (int)node["offset_grab"];
		m_cparam->min_distance_grab = (double)node["min_distance_grab"];
		m_cparam->min_area_ratio_grab = (double)node["min_area_ratio_grab"];
		m_cparam->max_area_ratio_grab = (double)node["max_area_ratio_grab"];
        m_cparam->rot_degree_grab = (double)node["rot_degree_grab"];
		
		m_cparam->model_path_cut = (string)node["model_path_cut"];
		m_cparam->object_threshold_cut = (float)node["object_threshold_cut"];
		m_cparam->nms_threshold_cut = (float)node["nms_threshold_cut"];
		m_cparam->grid_row_cut = (int)node["grid_row_cut"];
		m_cparam->grid_col_cut = (int)node["grid_col_cut"];
		m_cparam->grid_padding_cut = (int)node["grid_padding_cut"];
		m_cparam->min_area_ratio_cut = (double)node["min_area_ratio_cut"];
		m_cparam->max_area_ratio_cut = (double)node["max_area_ratio_cut"];
		m_cparam->kp3_weight_cut = (double)node["kp3_weight_cut"];
		
  }
	string get_cparam_info(ConfigParam*m_cparam)
	{
		if(!m_cparam){return string("");}

		stringstream buff;
		buff << "{" <<endl
			<< "image_show:\t"<<  m_cparam->image_show << endl
			<< "image_return:\t"<<  m_cparam->image_return << endl
			

			<<"image_save:\t"<<m_cparam->image_save << endl
			<<"image_depository:\t"<<m_cparam->image_depository << endl
			<<"image_backup_days:\t"<<m_cparam->image_backup_days << endl
			<<"model_path_grab:\t"<<m_cparam->model_path_grab << endl
			<<"object_threshold_grab:\t"<<m_cparam->object_threshold_grab << endl
			<<"nms_threshold_grab:\t"<<m_cparam->nms_threshold_grab << endl
			<< "grid_row_grab:\t" << m_cparam->grid_row_grab << endl
			<< "grid_col_grab:\t" << m_cparam->grid_col_grab << endl
			<< "grid_padding_grab:\t" << m_cparam->grid_padding_grab << endl
			<< "offset_grab:\t" << m_cparam->offset_grab << endl
			<< "min_distance_grab:\t" << m_cparam->min_distance_grab << endl
			<< "min_area_ratio_grab:\t" << m_cparam->min_area_ratio_grab << endl
			<< "max_area_ratio_grab:\t" << m_cparam->max_area_ratio_grab << endl
            << "rot_degree_grab:\t" << m_cparam->rot_degree_grab << endl

			<< "model_path_cut:\t" << m_cparam->model_path_cut << endl
			<< "object_threshold_cut:\t" << m_cparam->object_threshold_cut << endl
			<< "nms_threshold_cut:\t" << m_cparam->nms_threshold_cut << endl
			<< "grid_row_cut:\t" << m_cparam->grid_row_cut << endl
			<< "grid_col_cut:\t" << m_cparam->grid_col_cut << endl
			<< "grid_padding_cut:\t" << m_cparam->grid_padding_cut << endl
			<< "min_area_ratio_cut:\t" << m_cparam->min_area_ratio_cut << endl
			<< "max_area_ratio_cut:\t" << m_cparam->max_area_ratio_cut << endl
			<< "kp3_weight_cut:\t" << m_cparam->kp3_weight_cut << endl

			<< "}" << endl; 	
		return buff.str();
	}
}