#pragma once

#include <opencv2\highgui\highgui.hpp>
#include "data_def_api.h"

using namespace std;
//using namespace cv;

namespace graft_cv{

	class CGCvConfig
	{
	public:
		CGCvConfig();
		~CGCvConfig();
		void setConfParam(ConfigParam*);		
		void write(cv::FileStorage &fs)const;
		void read(const cv::FileNode& node);
	private:
		ConfigParam* m_cparam;	

	};
	//These write and read functions must exist as per the inline functions in operations.hpp
	static void write(cv::FileStorage& fs, const std::string&, const CGCvConfig& x){
	  x.write(fs);
	}
	static void read(const cv::FileNode& node, CGCvConfig& x, const CGCvConfig& default_value = CGCvConfig()){
	  if(node.empty())
		x = default_value;
	  else
		x.read(node);
	}
	string get_cparam_info(ConfigParam* m_cparam);
};